#!/bin/bash

DIR=/root/ssh_9.8_o

#创建管理员用户
id tencent
if [ $? = 0 ];then
	echo -e "\033[33m tencent用户已存在! \033[0m"
else
	useradd -m -s /bin/bash tencent
	echo "tencent:Asdf3.14" | chpasswd
	if [ -f /etc/sudoers_`date +%Y%m%d` ];then
        	echo -e "\033[33m /etc/sudoers文件已备份! \033[0m"
	else
		cp /etc/sudoers /etc/sudoers_`date +%Y%m%d`
	fi
	sed -i '83atencent ALL=(ALL) ALL' /etc/sudoers
	if [ $? = 0 ];then
        	echo -e "\033[33m tencent用户已添加为管理员! \033[0m"
	else
		echo -e "\033[31m tencent管理员用户添加失败!!! \033[0m"
	fi
	chage -M 99999 tencent
	if [ $? = 0 ];then
		echo -e "\033[33m tencent用户最长使用期限已修改为99999天! \033[0m"
	else
		echo -e "\033[31m tencent用户最长使用期限设置失败!!! \033[0m"
	fi
fi

#telnet服务
grep "pts/3" /etc/securetty
if [ $? = 0 ];then
	echo -e "\033[33m /etc/securetty文件已设置 \033[0m"
else
cat >>/etc/securetty << EOF
pts/0
pts/1
pts/2
pts/3
EOF
fi

rpm -qa | grep telnet-server
if [ $? = 0 ];then
	rpm -e telnet-server --nodeps
else
	echo ""
fi
rpm -ivh ${DIR}/telnet-server-0.17-66.el7.x86_64.rpm
if [ $? = 0 ];then
	systemctl start telnet.socket
	netstat -tnlp | grep -w 23
	if [ $? = 0 ];then
		echo -e "\033[33m telnet服务已安装成功，可使用tencent用户登录! \033[0m"
		#升级openssh
		#ssh_path=/data
		if [ -f /etc/ssh_bak`date '+%Y%m%d'` ];then
			echo -e "\033[33m ssh配置文件已备份! \033[0m"
		else
			mkdir  -p /etc/{ssh_bak`date '+%Y%m%d'`,pam_bak`date '+%Y%m%d'`}
			cp /etc/ssh/sshd_config /etc/ssh/sshd_config_bak
			sed -i  '/^Ciphers/d' /etc/ssh/sshd_config
			sed -i  '/^MACs/d' /etc/ssh/sshd_config
			sed -i  '/^HostbasedAcceptedKeytypes/d' /etc/ssh/sshd_config
			sed -i  '/^GSSAPIKexAlgorithms/d' /etc/ssh/sshd_config
			sed -i  '/^CASignatureAlgorithms/d' /etc/ssh/sshd_config
			sed -i  '/^HostKeyAlgorithms/d' /etc/ssh/sshd_config
			sed -i  '/^PubkeyAcceptedKeyTypes/d' /etc/ssh/sshd_config

			cp -arf /etc/ssh/* /etc/ssh_bak`date '+%Y%m%d'`/
			cp -arf /etc/pam.d/* /etc/pam_bak`date '+%Y%m%d'`/
		fi
		rpm -qa | grep pam-devel
		if [ $? = 0 ];then
			echo ""
		else
			rpm -ivh ${DIR}/pam-devel-1.1.8-23.el7.x86_64.rpm
		fi
		#tar -xvzf /data/ssh_9.3p2.tar.gz -C  /data
		rpm -Uvh ${DIR}/openssh-*.rpm --nodeps
		if [ "$?" = 0 ];then
		        /usr/bin/echo -e "\033[33m Openssh upgrade completed!!! \033[0m"
		        ssh_version=`ssh -V 2>&1 | awk -F ', ' '{print $1}'`
		        /usr/bin/echo -e "\033[33m The openssh version is ${ssh_version}! \033[0m"
			if [ -f /etc/ssh_9.8bak ];then
				rm -rf /etc/ssh_9.8bak/*
				rm -rf /etc/pam_9.8bak/*
				mv /etc/ssh/* /etc/ssh_9.8bak/
				mv /etc/pam.d/*  /etc/pam_9.8bak/
			else
				mkdir  -p  /etc/{ssh_9.8bak,pam_9.8bak}
				mv /etc/ssh/* /etc/ssh_9.8bak/
				mv /etc/pam.d/*  /etc/pam_9.8bak/
			fi
		        cp -arf /etc/ssh_bak`date '+%Y%m%d'`/* /etc/ssh/ >>out.log  2>&1
			cp -arf /etc/pam_bak`date '+%Y%m%d'`/* /etc/pam.d/ >>out.log  2>&1

			chmod 600 /etc/ssh/ssh*key
			rl=`grep PermitRootLogin /etc/ssh/sshd_config  | grep -v "#" | wc -l`
			if [ $rl = 0 ];then
				sed -i 's/#PermitRootLogin yes/PermitRootLogin yes/g' /etc/ssh/sshd_config
				echo -e "\033[33m sshd已修改为允许root登录 \033[0m"
		    else
		        echo -e "\033[33m sshd已配置允许root登录，无需修改 \033[0m"
		    fi
			systemctl daemon-reload 
		    systemctl restart sshd
			netstat -tnlp | grep -w  22
			if [ $? = 0 ];then
				echo -e "\033[33m sshd服务已启动！！\033[0m"
				systemctl stop telnet.socket
				echo -e "\033[33m telnet服务已关闭！！\033[0m"
				/sbin/chkconfig sshd on
				chkconfig --list sshd 2>&1 | tail -1 | grep -E "2:开|2:on"
				if [ $? = 0 ];then
					echo -e "\033[33m sshd服务已设置开机自启！\033[0m"
				else
					echo -e "\033[31m sshd服务设置开机自启失败！ \033[0m"
				fi
			else
				echo -e "\033[31m sshd服务异常，请使用telnet服务登录查看！ \033[0m"
			fi
		else
			/usr/bin/echo -e "\033[31m Openssh upgrade failed!!! \033[0m"
		fi
	else
		echo -e "\033[31m telnet服务启动失败，请检查日志，exit！！ \033[0m"
	fi
else
	echo -e "\033[31m telnet服务安装失败，请检查日志，exit！！ \033[0m"
fi
